## gitaly 16.8.2+ds3

=== Makefile ===
# Makefile for Gitaly

# You can override options by creating a "config.mak" file in Gitaly's root
# directory.
-include config.mak

# Unexport environment variables which have an effect on Git itself.
# We need to keep GIT_PREFIX because it's used to determine where our
# self-built Git should be installed into. It's probably not going to
# matter much though.
unexport $(filter-out GIT_PREFIX,$(shell git rev-parse --local-env-vars))

# Call `make V=1` in order to print commands verbosely.
ifeq ($(V),1)
    Q =
else
    Q = @
endif

SHELL = /usr/bin/env bash -eo pipefail

# Host information
OS   := $(shell uname)
ARCH := $(shell uname -m)

# Directories
SOURCE_DIR       := $(abspath $(dir $(lastword ${MAKEFILE_LIST})))
BUILD_DIR        := ${SOURCE_DIR}/_build
PROTO_DEST_DIR   := ${SOURCE_DIR}/proto/go
DEPENDENCY_DIR   := ${BUILD_DIR}/deps
TOOLS_DIR        := ${BUILD_DIR}/tools

# These variables may be overridden at runtime by top-level make
## The prefix where Gitaly binaries will be installed to. Binaries will end up
## in ${PREFIX}/bin by default.
PREFIX           ?= /usr/local
prefix           ?= ${PREFIX}
exec_prefix      ?= ${prefix}
bindir           ?= ${exec_prefix}/bin
INSTALL_DEST_DIR := ${DESTDIR}${bindir}
## The prefix where Git will be installed to.
GIT_PREFIX       ?= ${PREFIX}

# Tools
GIT                         := $(shell command -v git)
GOIMPORTS                   := ${TOOLS_DIR}/goimports
GOFUMPT                     := ${TOOLS_DIR}/gofumpt
GOLANGCI_LINT               := ${TOOLS_DIR}/golangci-lint
PROTOLINT                   := ${TOOLS_DIR}/protolint
GO_LICENSES                 := ${TOOLS_DIR}/go-licenses
PROTOC                      := ${TOOLS_DIR}/protoc
PROTOC_GEN_GO               := ${TOOLS_DIR}/protoc-gen-go
PROTOC_GEN_GO_GRPC          := ${TOOLS_DIR}/protoc-gen-go-grpc
PROTOC_GEN_GITALY_LINT      := ${TOOLS_DIR}/protoc-gen-gitaly-lint
PROTOC_GEN_GITALY_PROTOLIST := ${TOOLS_DIR}/protoc-gen-gitaly-protolist
PROTOC_GEN_DOC              := ${TOOLS_DIR}/protoc-gen-doc
GOTESTSUM                   := ${TOOLS_DIR}/gotestsum
GOCOVER_COBERTURA           := ${TOOLS_DIR}/gocover-cobertura
DELVE                       := ${TOOLS_DIR}/dlv

# Tool options
GOLANGCI_LINT_OPTIONS ?=
GOLANGCI_LINT_CONFIG  ?= ${SOURCE_DIR}/.golangci.yml

# Build information
GITALY_PACKAGE    := $(shell go list -m 2>/dev/null || echo unknown)
GITALY_VERSION    := $(shell ${GIT} describe --match v* 2>/dev/null | sed 's/^v//' || cat ${SOURCE_DIR}/VERSION 2>/dev/null || echo unknown)
GO_LDFLAGS        := -X ${GITALY_PACKAGE}/internal/version.version=${GITALY_VERSION}
SERVER_BUILD_TAGS := tracer_static,tracer_static_jaeger,tracer_static_stackdriver,continuous_profiler_stackdriver

# Temporary GNU build ID used as a placeholder value so that we can replace it
# with our own one after binaries have been built. This is the ASCII encoding
# of the string "TEMP_GITALY_BUILD_ID".
TEMPORARY_BUILD_ID := 54454D505F474954414C595F4255494C445F4944

## FIPS_MODE controls whether to build Gitaly and dependencies in FIPS mode.
## Set this to a non-empty value to enable it.
FIPS_MODE ?=

ifdef FIPS_MODE
    SERVER_BUILD_TAGS := ${SERVER_BUILD_TAGS},fips

    # Build Git with the OpenSSL backend for SHA256 in case FIPS-mode is
    # requested. Note that we explicitly don't do the same for SHA1: we
    # instead use SHA1DC to protect users against the SHAttered attack.
    GIT_FIPS_BUILD_OPTIONS := OPENSSL_SHA256=YesPlease

    # Go 1.19+ now requires GOEXPERIMENT=boringcrypto for FIPS compilation.
    # See https://github.com/golang/go/issues/51940 for more details.
    BORINGCRYPTO_SUPPORT := $(shell GOEXPERIMENT=boringcrypto go version > /dev/null 2>&1; echo $$?)
    ifeq ($(BORINGCRYPTO_SUPPORT), 0)
        export GOEXPERIMENT=boringcrypto
    endif

    export GITALY_TESTING_ENABLE_FIPS := YesPlease
endif

# protoc target
PROTOC_VERSION      ?= v23.1
PROTOC_REPO_URL     ?= https://github.com/protocolbuffers/protobuf
PROTOC_SOURCE_DIR   ?= ${DEPENDENCY_DIR}/protobuf/source
PROTOC_BUILD_DIR    ?= ${DEPENDENCY_DIR}/protobuf/build
PROTOC_INSTALL_DIR  ?= ${DEPENDENCY_DIR}/protobuf/install

ifeq ($(origin PROTOC_BUILD_OPTIONS),undefined)
    ## Build options for protoc.
    PROTOC_BUILD_OPTIONS ?=
    PROTOC_BUILD_OPTIONS += -DBUILD_SHARED_LIBS=NO
    PROTOC_BUILD_OPTIONS += -DCMAKE_INSTALL_PREFIX=${PROTOC_INSTALL_DIR}
    PROTOC_BUILD_OPTIONS += -Dprotobuf_BUILD_TESTS=OFF
    PROTOC_BUILD_OPTIONS += -DCMAKE_CXX_STANDARD=14
endif

# Git target
GIT_REPO_URL       ?= https://gitlab.com/gitlab-org/git.git
GIT_QUIET          :=
ifeq (${Q},@)
    GIT_QUIET = --quiet
endif

GIT_EXECUTABLES += git
GIT_EXECUTABLES += git-remote-http
GIT_EXECUTABLES += git-http-backend

## The version of Git to build and test Gitaly with when not used
## WITH_BUNDLED_GIT=YesPlease. Can be set to an arbitrary Git revision with
## tags, branches, and commit ids.
GIT_VERSION ?=
## The Git version used for bundled Git v2.42.
GIT_VERSION_2_42 ?= v2.42.0
## The Git version used for bundled Git v2.43.
GIT_VERSION_2_43 ?= v2.43.0

## Skip overriding the Git version and instead use the Git version as specified
## in the Git sources. This is required when building Git from a version that
## cannot be parsed by Gitaly.
SKIP_OVERRIDING_GIT_VERSION ?=

# The default version is used in case the caller does not set the variable or
# if it is either set to the empty string or "default".
ifeq (${GIT_VERSION:default=},)
    override GIT_VERSION := ${GIT_VERSION_2_42}
else
    # Support both vX.Y.Z and X.Y.Z version patterns, since callers across GitLab
    # use both.
    override GIT_VERSION := $(shell echo ${GIT_VERSION} | awk '/^[0-9]\.[0-9]+\.[0-9]+$$/ { printf "v" } { print $$1 }')
endif

ifeq ($(origin GIT_BUILD_OPTIONS),undefined)
    ## Build options for Git.
    GIT_BUILD_OPTIONS ?=
    # activate developer checks
    GIT_BUILD_OPTIONS += DEVELOPER=1
    # but don't cause warnings to fail the build
    GIT_BUILD_OPTIONS += DEVOPTS=no-error
    GIT_BUILD_OPTIONS += USE_LIBPCRE=YesPlease
    GIT_BUILD_OPTIONS += NO_PERL=YesPlease
    GIT_BUILD_OPTIONS += NO_EXPAT=YesPlease
    GIT_BUILD_OPTIONS += NO_TCLTK=YesPlease
    GIT_BUILD_OPTIONS += NO_GETTEXT=YesPlease
    GIT_BUILD_OPTIONS += NO_PYTHON=YesPlease
    PCRE_PC=libpcre2-8
    ifeq ($(shell pkg-config --exists ${PCRE_PC} && echo exists),exists)
	    GIT_BUILD_OPTIONS += LIBPCREDIR=$(shell pkg-config ${PCRE_PC} --variable prefix)
    endif
endif

ifdef GIT_APPEND_BUILD_OPTIONS
	GIT_BUILD_OPTIONS += ${GIT_APPEND_BUILD_OPTIONS}
endif

ifdef GIT_FIPS_BUILD_OPTIONS
	GIT_BUILD_OPTIONS += ${GIT_FIPS_BUILD_OPTIONS}
endif

# These variables control test options and artifacts
## List of Go packages which shall be tested.
## Go packages to test when using the test-go target.
TEST_PACKAGES     ?= ${SOURCE_DIR}/...
## Test options passed to `go test`.
TEST_OPTIONS      ?= -count=1
## Specify the output format used to print tests ["standard-verbose", "standard-quiet", "short"]
TEST_FORMAT       ?= short
## Specify the location where the JUnit-style format shall be written to.
TEST_JUNIT_REPORT ?= ${BUILD_DIR}/reports/tests-junit.xml
## Specify the location where the full JSON report shall be written to.
TEST_JSON_REPORT  ?=
## Specify the output directory for test coverage reports.
TEST_COVERAGE_DIR ?= ${BUILD_DIR}/cover
## Directory where all runtime test data is being created.
TEST_TMP_DIR      ?=
## Directory where Gitaly should write logs to during test execution.
TEST_LOG_DIR	  ?=
TEST_REPO_DIR     := ${BUILD_DIR}/testrepos
BENCHMARK_REPO    := ${TEST_REPO_DIR}/benchmark.git
## Options to pass to the script which builds the Gitaly gem
BUILD_GEM_OPTIONS ?=
## Options to override the name of Gitaly gem
BUILD_GEM_NAME ?= gitaly

# All executables provided by Gitaly.
GITALY_EXECUTABLES           = $(addprefix ${BUILD_DIR}/bin/,$(notdir $(shell find ${SOURCE_DIR}/cmd -mindepth 1 -maxdepth 1 -type d -print)))
# All executables packed inside the Gitaly binary.
GITALY_PACKED_EXECUTABLES    = $(filter %gitaly-hooks %gitaly-gpg %gitaly-ssh %gitaly-lfs-smudge, ${GITALY_EXECUTABLES})
# All executables that should be installed.
GITALY_INSTALLED_EXECUTABLES = $(filter-out ${GITALY_PACKED_EXECUTABLES}, ${GITALY_EXECUTABLES})
# Find all Go source files.
find_go_sources              = $(shell find ${SOURCE_DIR} -type d \( -path "${SOURCE_DIR}/_*" -o -path "${SOURCE_DIR}/proto" \) -prune -o -type f -name '*.go' -print | sort -u)

# run_go_tests will execute Go tests with all required parameters. Its
# behaviour can be modified via the following variables:
#
# TEST_OPTIONS: any additional options
# TEST_PACKAGES: packages which shall be tested
# TEST_LOG_DIR: specify the output log dir. By default, all logs will be discarded
run_go_tests = PATH='${SOURCE_DIR}/internal/testhelper/testdata/home/bin:${PATH}' \
    TEST_TMP_DIR='${TEST_TMP_DIR}' \
    TEST_LOG_DIR='${TEST_LOG_DIR}' \
    ${GOTESTSUM} --format ${TEST_FORMAT} --junitfile '${TEST_JUNIT_REPORT}' --jsonfile '${TEST_JSON_REPORT}' -- -ldflags '${GO_LDFLAGS}' -tags '${SERVER_BUILD_TAGS}' ${TEST_OPTIONS} ${TEST_PACKAGES}

## Test options passed to `dlv test`.
DEBUG_OPTIONS      ?= $(patsubst -%,-test.%,${TEST_OPTIONS})

# debug_go_tests will execute Go tests from a single package in the delve debugger.
# Its behaviour can be modified via the following variable:
#
# DEBUG_OPTIONS: any additional options, will default to TEST_OPTIONS if not set.
debug_go_tests = PATH='${SOURCE_DIR}/internal/testhelper/testdata/home/bin:${PATH}' \
    TEST_TMP_DIR='${TEST_TMP_DIR}' \
    ${DELVE} test --build-flags="-ldflags '${GO_LDFLAGS}' -tags '${SERVER_BUILD_TAGS}'" ${TEST_PACKAGES} -- ${DEBUG_OPTIONS}

unexport GOROOT
## GOCACHE_MAX_SIZE_KB is the maximum size of Go's build cache in kilobytes before it is cleaned up.
GOCACHE_MAX_SIZE_KB              ?= 5000000
export GOCACHE                   ?= ${BUILD_DIR}/cache
export GOPROXY                   ?= https://proxy.golang.org|https://proxy.golang.org
export PATH                      := ${BUILD_DIR}/bin:${PATH}

# By default, intermediate targets get deleted automatically after a successful
# build. We do not want that though: there's some precious intermediate targets
# like our `*.version` targets which are required in order to determine whether
# a dependency needs to be rebuilt. By specifying `.SECONDARY`, intermediate
# targets will never get deleted automatically.
.SECONDARY:

.PHONY: all
## Default target which builds Gitaly.
all: build

.PHONY: .FORCE
.FORCE:

## Print help about available targets and variables.
help:
	@echo "usage: make [<target>...] [<variable>=<value>...]"
	@echo ""
	@echo "These are the available targets:"
	@echo ""

	@ # Match all targets which have preceding `## ` comments.
	${Q}awk '/^## / { sub(/^##/, "", $$0) ; desc = desc $$0 ; next } \
		 /^[[:alpha:]][[:alnum:]_-]+:/ && desc { print "  " $$1 desc } \
		 { desc = "" }' $(MAKEFILE_LIST) | sort | column -s: -t

	${Q}echo ""
	${Q}echo "These are common variables which can be overridden in config.mak"
	${Q}echo "or by passing them to make directly as environment variables:"
	${Q}echo ""

	@ # Match all variables which have preceding `## ` comments and which are assigned via `?=`.
	${Q}awk '/^[[:space:]]*## / { sub(/^[[:space:]]*##/,"",$$0) ; desc = desc $$0 ; next } \
		 /^[[:space:]]*[[:alpha:]][[:alnum:]_-]+[[:space:]]*\?=/ && desc { print "  "$$1 ":" desc } \
		 { desc = "" }' $(MAKEFILE_LIST) | sort | column -s: -t

.PHONY: build
## Build Go binaries.
build: ${GITALY_INSTALLED_EXECUTABLES}

.PHONY: install
## Install Gitaly binaries. The target directory can be modified by setting PREFIX and DESTDIR.
install: build
	${Q}mkdir -p ${INSTALL_DEST_DIR}
	install ${GITALY_INSTALLED_EXECUTABLES} "${INSTALL_DEST_DIR}"

.PHONY: build-bundled-git
## Build bundled Git binaries.
build-bundled-git: build-bundled-git-v2.42 build-bundled-git-v2.43
build-bundled-git-v2.42: $(patsubst %,${BUILD_DIR}/bin/gitaly-%-v2.42,${GIT_EXECUTABLES})

=== debian/changelog ===
gitaly (16.8.2+ds3-2) unstable; urgency=medium

  * Reupload to unstable

 -- Pirate Praveen <praveen@debian.org>  Mon, 19 Feb 2024 18:46:30 +0530

gitaly (16.8.2+ds3-1) experimental; urgency=medium

  * New upstream version 16.8.2+ds3 (drop 2 modules from vendor)
  * Update minimum version of gitlab-shell to 14.33~
  * Add golang-github-miekg-dns-dev as build dependency

 -- Pirate Praveen <praveen@debian.org>  Wed, 14 Feb 2024 18:10:22 +0530

gitaly (16.8.2+ds2-1) experimental; urgency=medium

  * Team Upload.

  [ Pirate Praveen ]
  * New upstream version 16.8.2
  * Drop obsolete patch
  * New upstream version 16.8.2+ds1 (Add go-grpc-middleware v2 to vendor)
  * New upstream version 16.8.2+ds2 (Add hashicorp/yamux to vendor)
  * Revert "Drop obsolete patch"
  * Reintroduce patch that was removed earlier (we still need it)

  [ Mohammed Bilal ]
  * Refresh patch
  * Pass -w option to build-proto-gem

 -- Mohammed Bilal <rmb@debian.org>  Sun, 11 Feb 2024 22:26:27 +0530

gitaly (16.6.5+ds1-7) unstable; urgency=medium

  * Move back gitlab_log_dir to gitlab-debian.conf (used by gitlab-puma)

 -- Pirate Praveen <praveen@debian.org>  Sun, 21 Jan 2024 16:50:42 +0530

gitaly (16.6.5+ds1-6) unstable; urgency=medium

  * Move back gitlab_app_root and gitlab_pid_path to gitlab-debian.conf
    (these two are needed by gitlab-workhorse.service)

 -- Pirate Praveen <praveen@debian.org>  Sun, 21 Jan 2024 15:52:00 +0530

gitaly (16.6.5+ds1-5) unstable; urgency=medium

  * Move +gitlab_app_root, gitlab_data_dir, gitlab_pid_path, gitlab_log_dir
    variable from gitlab-debian.conf to gitlab-common.defaults (for
    gem-install.sh which needs to run before gitlab-debian.conf is created)

 -- Pirate Praveen <praveen@debian.org>  Sun, 21 Jan 2024 13:30:39 +0530

gitaly (16.6.5+ds1-4) unstable; urgency=medium

  * Reupload to unstable
  * Drop obsolete X?-Ruby-Versions from d/control

 -- Pirate Praveen <praveen@debian.org>  Fri, 19 Jan 2024 13:21:38 +0530

gitaly (16.6.5+ds1-3) experimental; urgency=medium

  * Create /etc/gitlab-common/logrotate-user.conf
    (this will be used for gitlab logrotate configuration)

 -- Pirate Praveen <praveen@debian.org>  Fri, 19 Jan 2024 13:21:29 +0530

gitaly (16.6.5+ds1-2) experimental; urgency=medium

  * Update minimum version of gitlab-shell to 14.30

 -- Pirate Praveen <praveen@debian.org>  Wed, 17 Jan 2024 01:50:22 +0530

gitaly (16.6.5+ds1-1) experimental; urgency=medium

  * Update minimum version of golang-go to 1:1.21~
  * New upstream version 16.6.5
  * New upstream version 16.6.5+ds1 (vendor go-grpc-middleware/v2)

 -- Pirate Praveen <praveen@debian.org>  Wed, 17 Jan 2024 00:37:29 +0530

gitaly (16.4.4+ds1-4) unstable; urgency=medium

  * Update minimum version of gitlab-shell to 14.28~

 -- Pirate Praveen <praveen@debian.org>  Fri, 22 Dec 2023 19:57:04 +0530

gitaly (16.4.4+ds1-3) unstable; urgency=medium

  * Really reupload to unstable

 -- Pirate Praveen <praveen@debian.org>  Tue, 19 Dec 2023 14:12:12 +0530

gitaly (16.4.4+ds1-2) experimental; urgency=medium

  * Reupload to unstable

 -- Pirate Praveen <praveen@debian.org>  Sun, 17 Dec 2023 21:54:41 +0530

gitaly (16.4.4+ds1-1) experimental; urgency=medium

  * New upstream version 16.4.4
  * Refresh patches
  * Drop golang-github-libgit2-git2go-v34-dev dependency
  * Remove failing test file
  * New upstream version 16.4.4+ds1 (add newer hashicorp/yamux)

 -- Pirate Praveen <praveen@debian.org>  Sun, 17 Dec 2023 01:09:11 +0530

gitaly (16.2.8+ds3-2) experimental; urgency=medium

  * Update minimum version of gitlab-shell to 14.23

 -- Pirate Praveen <praveen@debian.org>  Wed, 13 Dec 2023 00:35:53 +0530

gitaly (16.2.8+ds3-1) experimental; urgency=medium

  * New upstream version 16.2.8+ds3 (update grpc in vendor)

 -- Pirate Praveen <praveen@debian.org>  Sun, 03 Dec 2023 00:39:24 +0530

gitaly (16.2.8+ds2-1) experimental; urgency=medium

  [ Mohammed Bilal ]
  * d/p: update remove-go-embed.patch
  * add patch to change auxiliary binaries location

  [ Pirate Praveen ]
  * New upstream version 16.2.8+ds1
  * Refresh patches
  * New upstream version 16.2.8+ds2 (update vendored modules)
  * Disable failing tests
  * Update minimum version of git to 2.41

 -- Pirate Praveen <praveen@debian.org>  Sat, 02 Dec 2023 20:07:02 +0530

=== debian/control ===
Source: gitaly
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Pirate Praveen <praveen@debian.org>,
 Sruthi Chandran <srud@debian.org>
Build-Depends: debhelper (>= 11~),
 dh-golang (>= 1.43~),
# See #1016217 (gccgo and x/net don't work well together right now)
# golang-any (>= 2:1.17~),
 golang-go (>= 2:1.21~),
 golang-github-aws-aws-sdk-go-dev,
 golang-github-azure-azure-pipeline-go-dev,
 golang-github-azure-azure-storage-blob-go-dev (>= 0.14~),
 golang-github-azure-go-autorest-dev (>= 14.2~),
 golang-github-beevik-ntp-dev,
 golang-github-beorn7-perks-dev,
 golang-github-burntsushi-toml-dev,
 golang-github-client9-reopen-dev,
 golang-github-cloudflare-tableflip-dev (>= 1.2~),
 golang-github-containerd-cgroups-dev,
 golang-github-davecgh-go-spew-dev,
 golang-github-dchest-safefile-dev,
 golang-github-getsentry-sentry-go-dev,
 golang-github-golang-jwt-jwt-dev,
 golang-github-git-lfs-git-lfs-dev (>= 3.0~),
 golang-github-golang-protobuf-1-5-dev,
 golang-github-google-uuid-dev,
 golang-github-google-wire-dev,
 golang-github-go-enry-go-license-detector-dev (>= 4.3.0+git20221007~),
# golang-github-grpc-ecosystem-go-grpc-middleware-dev (>= 1.2.3~),
# golang-github-grpc-ecosystem-go-grpc-prometheus-dev (>= 1.2~),
 golang-github-hashicorp-golang-lru-dev,
 golang-github-hashicorp-yamux-dev (>= 0.0+git20210316.a95892c~),
 golang-github-jackc-pgconn-dev,
 golang-github-jackc-pgx-v4-dev,
 golang-github-kelseyhightower-envconfig-dev,
 golang-github-lib-pq-dev (>= 1.3~),
 golang-github-miekg-dns-dev (>= 1.1.54~),
 golang-github-opencontainers-specs-dev,
 golang-github-opentracing-opentracing-go-dev,
 golang-github-oklog-ulid-dev (>= 2.0~),
 golang-github-pelletier-go-toml.v2-dev,
 golang-github-pmezard-go-difflib-dev,
# golang-github-prometheus-client-golang-dev,
# golang-github-prometheus-client-model-dev,
# golang-github-prometheus-common-dev,
 golang-github-rubenv-sql-migrate-dev,
 golang-github-sebest-xff-dev,
 golang-github-sirupsen-logrus-dev (>= 1.0~),
 golang-github-stretchr-testify-dev (>= 1.4~),
 golang-github-urfave-cli-v2-dev,
 golang-gitlab-gitlab-org-gitlab-shell-v14-dev (>= 14.20~),
# golang-gitlab-gitlab-org-labkit-dev (>= 1.16~),
# golang-gocloud-dev,
 golang-golang-x-crypto-dev,
 golang-golang-x-net-dev,
 golang-golang-x-oauth2-dev (>= 0.0~git20211104.d3ed0bb),
 golang-golang-x-oauth2-google-dev (>= 0.0~git20211104.d3ed0bb),
 golang-golang-x-sync-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-text-dev,
 golang-golang-x-time-dev,
 golang-golang-x-tools-dev,
 golang-golang-x-xerrors-dev,
# golang-google-grpc-dev (>= 1.38.0-3~),
 golang-google-protobuf-dev,
 golang-gopkg-gorp.v1-dev,
 golang-gopkg-yaml.v2-dev,
 golang-honnef-go-tools-dev,
 golang-procfs-dev,
# golang-protobuf-extensions-dev,
 golang-uber-goleak-dev,
 protobuf-compiler,
# Tests:
#  ,git
#  ,procps
# required for vendored gocloud.dev
 golang-github-aws-smithy-go-dev,
 golang-github-kylelemons-godebug-dev,
 golang-github-cli-browser-dev,
 gem2deb (>= 2.1~),
 ruby-grpc-tools (>= 1.42~),
 ruby-bundler
Standards-Version: 4.6.2
Homepage: https://gitlab.com/gitlab-org/gitaly
Vcs-Git: https://salsa.debian.org/go-team/packages/gitaly.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/gitaly
XS-Go-Import-Path: gitlab.com/gitlab-org/gitaly/v16

Package: gitaly
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends}, ${misc:Depends},
     gitlab-common (=${source:Version}),
# sysv deps:
     pipexec,
     procps
Conflicts: libruby2.5
Description: Git RPC service for handling all the git calls made by GitLab
 Gitaly makes the git data storage tier of large GitLab instances fast.
 .
 This is achieved by moving git operations as close to the data as possible and
 Optimizing git services using caching.
 .
 Gitaly is a core service of gitlab.

Package: ruby-gitaly
Section: ruby
Architecture: all
Depends: ruby,
         ruby-grpc (>= 1.0~),
         ${misc:Depends},
         ${ruby:Depends},
         ${shlibs:Depends}
Description: Auto-generated gRPC client for gitaly
 Auto-generated gRPC ruby client for gitaly.
 .
 Gitaly is part of GitLab. It is a server application that uses its own gRPC
 protocol to communicate with its clients.

Package: gitlab-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${ruby:Depends},
 ruby,
 adduser (>= 3.34~),
 git (>= 1:2.41~),
 ucf,
 gitlab-shell (>= 14.33~)
Description: git powered software platform to collaborate on code (common)
 gitlab provides web based interface to host source code and track issues.
 It allows anyone for fork a repository and send merge requests. Code review
 is possible using merge request workflow. Using groups and roles project
 access can be controlled.
 .
 This package includes configurations common to gitlab and gitaly.

Package: golang-gitlab-gitlab-org-gitaly-dev
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
         golang-github-aws-aws-sdk-go-dev,
         golang-github-azure-azure-pipeline-go-dev,
         golang-github-azure-azure-storage-blob-go-dev (>= 0.14~),
         golang-github-azure-go-autorest-dev (>= 14.2~),
         golang-github-beevik-ntp-dev,
         golang-github-beorn7-perks-dev,
         golang-github-burntsushi-toml-dev,
         golang-github-client9-reopen-dev,
         golang-github-cloudflare-tableflip-dev (>= 1.2~),
         golang-github-containerd-cgroups-dev,
         golang-github-davecgh-go-spew-dev,
         golang-github-dchest-safefile-dev,
         golang-github-getsentry-sentry-go-dev,
         golang-github-git-lfs-git-lfs-dev (>= 3.0~),
         golang-github-golang-protobuf-1-5-dev,
         golang-github-google-uuid-dev,
         golang-github-google-wire-dev,
         golang-github-go-enry-go-license-detector-dev (>= 4.3.0+git20221007~),
#         golang-github-grpc-ecosystem-go-grpc-middleware-dev (>= 1.2.3~),
#         golang-github-grpc-ecosystem-go-grpc-prometheus-dev (>= 1.2~),
         golang-github-hashicorp-golang-lru-dev,
         golang-github-hashicorp-yamux-dev (>= 0.0+git20210316.a95892c~),
         golang-github-jackc-pgconn-dev,
         golang-github-jackc-pgx-v4-dev,
         golang-github-kelseyhightower-envconfig-dev,
         golang-github-lib-pq-dev (>= 1.3~),
         golang-github-miekg-dns-dev (>= 1.1.54~),
         golang-github-opencontainers-specs-dev,
         golang-github-opentracing-opentracing-go-dev,
         golang-github-oklog-ulid-dev (>= 2.0~),
         golang-github-pelletier-go-toml.v2-dev,
         golang-github-pmezard-go-difflib-dev,
#         golang-github-prometheus-client-golang-dev,
#         golang-github-prometheus-client-model-dev,
#         golang-github-prometheus-common-dev,
         golang-github-rubenv-sql-migrate-dev,
         golang-github-sebest-xff-dev,
         golang-github-sirupsen-logrus-dev (>= 1.0~),
         golang-github-stretchr-testify-dev (>= 1.8~),
         golang-gitlab-gitlab-org-gitlab-shell-v14-dev (>= 14.18~),
#         golang-gitlab-gitlab-org-labkit-dev,
#         golang-gocloud-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-oauth2-dev (>= 0.0~git20211104.d3ed0bb),
         golang-golang-x-oauth2-google-dev (>= 0.0~git20211104.d3ed0bb),
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-text-dev,
         golang-golang-x-time-dev,
         golang-golang-x-tools-dev,
         golang-golang-x-xerrors-dev,
#         golang-google-grpc-dev (>= 1.38.0-3~),
         golang-google-protobuf-dev,
         golang-gopkg-gorp.v1-dev,
         golang-gopkg-yaml.v2-dev,
         golang-honnef-go-tools-dev,
         golang-procfs-dev,
#         golang-protobuf-extensions-dev,
         golang-uber-goleak-dev,
Description: Gitaly golang module
 Gitaly makes the git data storage tier of large GitLab instances fast.
 .
 This is achieved by moving git operations as close to the data as possible and
 Optimizing git services using caching.
 .
 Gitaly is a core service of gitlab.
 .
 This package provides golang module of gitaly.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DH_GOLANG_GO_GENERATE := 1
#export DH_GOLANG_INSTALL_ALL := 1  # test data
#export DH_GOLANG_INSTALL_EXTRA := vendor
export DH_RUBY = --gem-install
export DH_RUBY_USE_DH_AUTO_INSTALL_DESTDIR = debian/ruby-gitaly
export GEM2DEB_TEST_RUNNER = --check-dependencies
export RAILS_ENV = development # for bundle install --local test
export GITALY_EXECUTABLES = $(addprefix gitlab.com/gitlab-org/gitaly/v16/cmd/,$(notdir $(shell find ${CURDIR}/cmd -mindepth 1 -maxdepth 1 -type d -print)))
# All executables packed inside the Gitaly binary.
export GITALY_PACKED_EXECUTABLES = $(filter %gitaly-hooks %gitaly-git2go %gitaly-ssh %gitaly-lfs-smudge, ${GITALY_EXECUTABLES})

include /usr/share/dpkg/pkg-info.mk
## Set some build variables as per Makefile:
VERSION  ?= $(shell sh -c 'printf "$${1%%+ds*}"' -- "$(DEB_VERSION_UPSTREAM)")
PKG := gitlab.com/gitlab-org/gitaly/v16
MODULE_VERSION := v16
GO_LDFLAGS ?= -X $(PKG)/internal/version.version=$(VERSION) -X $(PKG)/internal/version.moduleVersion=$(MODULE_VERSION)
GO_BUILD_TAGS ?= static,system_libgit2

%:
	dh $@  --buildsystem=golang --with=golang --package=golang-gitlab-gitlab-org-gitaly-dev \
	--builddirectory=_build
	dh $@  --buildsystem=ruby --with=ruby --package=ruby-gitaly
	dh $@  --package=gitlab-common
	dh $@  --package=gitaly

override_dh_auto_clean:
	rm -rf ruby/proto/gitaly/*_pb.rb
	dh_auto_clean -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	-O--builddirectory=_build
	dh_auto_clean -O--buildsystem=ruby -O--package=ruby-gitaly

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	-O--builddirectory=_build

override_dh_auto_build:
	dh_auto_build -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	-O--builddirectory=_build -- \
	   -ldflags "$(GO_LDFLAGS)" -tags "$(GO_BUILD_TAGS)" \
           $(GITALY_PACKED_EXECUTABLES)
	mkdir -p _build/src/${PKG}/_build/ && cp -a _build/bin _build/src/${PKG}/_build/
	dh_auto_build -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	-O--builddirectory=_build -- \
	   -ldflags "$(GO_LDFLAGS)" -tags "$(GO_BUILD_TAGS)" \
           gitlab.com/gitlab-org/gitaly/${MODULE_VERSION}/cmd/gitaly
	rm -rf _build/src/${PKG}/_build/
	rm tools/protogem/Gemfile.lock
	RAILS_ENV=$(RAILS_ENV) BUNDLE_GEMFILE=tools/protogem/Gemfile \
	bundle install --local
	RAILS_ENV=$(RAILS_ENV) BUNDLE_GEMFILE=tools/protogem/Gemfile \
	bundle exec tools/protogem/build-proto-gem -o gitaly.gem -w .
	dh_auto_build -O--buildsystem=ruby -O--package=ruby-gitaly

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	# Test hangs, so don't even run it
	#-dh_auto_test -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	#-O--builddirectory=_build
	dh_auto_test -O--buildsystem=ruby -O--package=ruby-gitaly
endif

override_dh_auto_install:
	dh_auto_install -O--buildsystem=golang -O--package=golang-gitlab-gitlab-org-gitaly-dev \
	-O--no-binaries --builddirectory=_build --destdir=debian/golang-gitlab-gitlab-org-gitaly-dev
	dh_auto_install -O--buildsystem=ruby -O--package=ruby-gitaly --destdir=debian/ruby-gitaly
	$(RM) -rv debian/golang-gitlab-gitlab-org-gitaly-dev/usr/bin
	# Remove testdata, contains files that triggers more lintian errors
	for f in `find debian/ -name testdata`; do \
		$(RM) -rv $$f; \
	done
